﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Automation;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;
using System.Diagnostics;

namespace Lesson_1
{
    /// <summary>
    /// Interaction logic for AutomationWindow.xaml
    /// </summary>
    public partial class AutomationWindow : Window
    {
        MainWindow aWindow;
        public AutomationWindow()
        {
            InitializeComponent();
            PresentationTraceSources.Refresh();
            TextWriterTraceListener listener;
            System.IO.Stream myFile = System.IO.File.Create("trace.txt");
            listener = new TextWriterTraceListener(myFile);
            PresentationTraceSources.RoutedEventSource.Switch.Level = SourceLevels.All;
            PresentationTraceSources.RoutedEventSource.Listeners.Add(listener);
            aWindow = new MainWindow();
            aWindow.Show();
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            RadioButtonAutomationPeer RBAutomationPeer = new RadioButtonAutomationPeer(aWindow.RadioButton2);
            ISelectionItemProvider SelectProvider;
            SelectProvider = (ISelectionItemProvider)RBAutomationPeer.GetPattern(PatternInterface.SelectionItem);
            SelectProvider.Select();
        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            CheckBoxAutomationPeer CBAutomationPeer1 = new CheckBoxAutomationPeer(aWindow.CheckBox1);
            CheckBoxAutomationPeer CBAutomationPeer2 = new CheckBoxAutomationPeer(aWindow.CheckBox2);
            IToggleProvider ToggProvider1;
            IToggleProvider ToggProvider2;
            ToggProvider1 = (IToggleProvider)CBAutomationPeer1.GetPattern(PatternInterface.Toggle);
            ToggProvider2 = (IToggleProvider)CBAutomationPeer2.GetPattern(PatternInterface.Toggle);
            ToggProvider1.Toggle();
            ToggProvider2.Toggle();
        }

        private void Button3_Click(object sender, RoutedEventArgs e)
        {
            ListBoxAutomationPeer LBAutomationPeer = new ListBoxAutomationPeer(aWindow.ListBox1);
            IScrollProvider ScrProvider;
            ScrProvider = (IScrollProvider)LBAutomationPeer.GetPattern(PatternInterface.Scroll);
            ScrProvider.Scroll(System.Windows.Automation.ScrollAmount.NoAmount, System.Windows.Automation.ScrollAmount.LargeIncrement);
            ScrProvider.Scroll(System.Windows.Automation.ScrollAmount.NoAmount, System.Windows.Automation.ScrollAmount.LargeIncrement);
            ListBoxItemAutomationPeer LBIAutomationPeer = new ListBoxItemAutomationPeer(aWindow.ListBox1.Items[3], LBAutomationPeer);
            ISelectionItemProvider SelItemProvider;
            SelItemProvider =(ISelectionItemProvider)LBIAutomationPeer.GetPattern(PatternInterface.SelectionItem);
            SelItemProvider.Select();
        }

        private void Button4_Click(object sender, RoutedEventArgs e)
        {
            ButtonAutomationPeer BAutomationPeer = new ButtonAutomationPeer(aWindow.Button1);
            IInvokeProvider InvProvider;
            InvProvider = (IInvokeProvider)BAutomationPeer.GetPattern(PatternInterface.Invoke);
            InvProvider.Invoke();
        }


    }
}
