﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Lesson_2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        NwindDataSet aset = new NwindDataSet();
        NwindDataSetTableAdapters.CustomersTableAdapter custAdap = new NwindDataSetTableAdapters.CustomersTableAdapter();
        NwindDataSetTableAdapters.OrdersTableAdapter ordAdap = new NwindDataSetTableAdapters.OrdersTableAdapter();
        NwindDataSetTableAdapters.Order_Details_ExtendedTableAdapter ord_det_extAdap = new NwindDataSetTableAdapters.Order_Details_ExtendedTableAdapter();
        public MainWindow()
        {
            InitializeComponent();
            custAdap.Fill(aset.Customers);
            ordAdap.Fill(aset.Orders);
            ord_det_extAdap.Fill(aset.Order_Details_Extended);
            Grid1.DataContext = aset.Customers;
            System.ComponentModel.ICollectionView aView;
            aView = CollectionViewSource.GetDefaultView(aset.Customers);
            aView.GroupDescriptions.Add(new PropertyGroupDescription("Country", new CountryGrouper()));
            aView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Country", System.ComponentModel.ListSortDirection.Ascending));
        }
    }
    public class CountryGrouper : IValueConverter
    {
        public object Convert(object value, System.Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string country = value.ToString();
            return "Country: " + country;
        }

        public object ConvertBack(object value, System.Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
    [ValueConversion(typeof(Decimal), typeof(String))]
    public class CurrencyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            decimal aDec;
            aDec = (decimal)value;
            return aDec.ToString("C");
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
    [ValueConversion(typeof(DateTime), typeof(Brush))]
    public class YearConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            DateTime aDate;
            aDate = (DateTime)value;
            switch (aDate.Year.ToString())
            {
                case "1994":
                    return new SolidColorBrush(Colors.Purple);
                case "1995":
                    return new SolidColorBrush(Colors.Green);
                case "1996":
                    return new SolidColorBrush(Colors.Red);
                default:
                    return new SolidColorBrush(Colors.Yellow);
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
