﻿Class Window1
    Dim aView As System.ComponentModel.ICollectionView
    Dim myNames As Names
    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myNames = CType(Me.Resources("myNames"), Names)
        aView = CollectionViewSource.GetDefaultView(myNames)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click
        If Not aView.CurrentPosition = 0 Then
            aView.MoveCurrentToPrevious()
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button2.Click
        If Not aView.CurrentPosition = myNames.Count - 1 Then
            aView.MoveCurrentToNext()
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button3.Click
        Dim aName As New Name("", "")
        myNames.Add(aName)
        aView.MoveCurrentToNext()
    End Sub

    Private Sub Grid_Error(ByVal sender As System.Object, ByVal e As System.Windows.Controls.ValidationErrorEventArgs)
        If e.Action = ValidationErrorEventAction.Added Then
            MessageBox.Show(e.Error.ErrorContent.ToString)
        End If
    End Sub
End Class
Public Class Name
    Implements System.ComponentModel.INotifyPropertyChanged
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
    Public Sub New(ByVal fName As String, ByVal lName As String)
        FirstName = fName
        LastName = lName
    End Sub

    Private mFirstName As String
    Private mLastName As String
    Public Property FirstName()
        Get
            Return mFirstName
        End Get
        Set(ByVal value)
            mFirstName = value
            RaiseEvent PropertyChanged(Me, New System.ComponentModel.PropertyChangedEventArgs("FirstName"))
        End Set
    End Property
    Public Property LastName()
        Get
            Return mLastName
        End Get
        Set(ByVal value)
            mLastName = value
            RaiseEvent PropertyChanged(Me, New System.ComponentModel.PropertyChangedEventArgs("LastName"))
        End Set
    End Property
End Class
Public Class Names
    Inherits System.Collections.ObjectModel.ObservableCollection(Of Name)
    Public Sub New()
        Dim aName As New Name("FirstName " & (Me.Count + 1).ToString, "LastName " & (Me.Count + 1).ToString)
        Me.Add(aName)
    End Sub
End Class
Public Class StringValidator
    Inherits ValidationRule

    Public Overrides Function Validate(ByVal value As Object, ByVal cultureInfo As System.Globalization.CultureInfo) As System.Windows.Controls.ValidationResult
        Dim astring As String = value.ToString
        If astring = "" Then
            Return New ValidationResult(False, "String Cannot Be Null")
        Else
            Return New ValidationResult(True, Nothing)
        End If

    End Function
End Class